# class Puppet::Parser::AST::Hostclass

### Attributes

context[RW]
name[RW]

### Public Class Methods

new(name, context = {}, &ruby_code) click to toggle source

    # File lib/puppet/parser/ast/hostclass.rb, line 6
    def initialize(name, context = {}, &ruby_code)
      @context = context
      @name = name
      @ruby_code = ruby_code
    end

### Public Instance Methods

code() click to toggle source

    # File lib/puppet/parser/ast/hostclass.rb, line 26
    def code()
      @context[:code]
    end

instantiate(modname) click to toggle source

    # File lib/puppet/parser/ast/hostclass.rb, line 12
    def instantiate(modname)
      new_class = Puppet::Resource::Type.new(:hostclass, @name, @context.merge(:module_name => modname))
      new_class.ruby_code = @ruby_code if @ruby_code
      all_types = [new_class]
      if code
        code.each do |nested_ast_node|
          if nested_ast_node.respond_to? :instantiate
            all_types += nested_ast_node.instantiate(modname)
          end
        end
      end
      return all_types
    end